<template>
  <app-form-dialog
    :title="mode"
    :name="name"
    :loading="loading"
    :on-submit="onSubmit"
  >
    <field-group-name
      class="col-xs-12"
      required
      :default-value="dialogProps?.name"
    />
  </app-form-dialog>
</template>

<script>
import AppFormDialog from 'src/components/dialogs/AppDialogForm';
import { ref, computed } from 'vue';
import { useDialog } from 'src/hooks/dialogs-provider';
import FieldGroupName from 'src/components/forms/form-fields/FieldGroupName';
import { useGroupMutation } from 'src/hooks/groups';

export default {
  name: 'DialogGroupUpsert',
  components: {
    FieldGroupName,
    AppFormDialog,
  },
  setup() {
    const name = ref('dialog-group-upsert');

    const { createGroup, updateGroup, groupIsCreating, groupIsUpdating } =
      useGroupMutation();

    const { dialogProps } = useDialog(name);

    const mode = computed(() =>
      dialogProps.value === undefined ? 'CREATE' : 'EDIT',
    );

    const loading = computed(() =>
      mode.value === 'CREATE' ? groupIsCreating.value : groupIsUpdating.value,
    );

    const onSubmit = (args) => {
      const newGroup = {
        ...dialogProps.value,
        ...args,
      };

      return Promise.resolve().then(() => {
        if (mode.value === 'CREATE') {
          return createGroup(newGroup);
        }
        return updateGroup(newGroup);
      });
    };

    return {
      name,
      mode,
      dialogProps,
      loading,
      onSubmit,
    };
  },
};
</script>
